Summary:            MOLAP Database Server
Name:               palo
Version:            5.1
Release:            4%{?dist}
License:            GPLv2
Group:              Applications/Databases
Source:             https://svn.code.sf.net/p/%{name}/code/molap/server/%{version}/palo-5.1.tgz
Patch0:             palo-5.1.4-cmake.patch
#Provide a systemd unit to start palo on boot: not provide by source tree
#http://www.jedox.com/community/palo-forum/index.php?page=Thread&threadID=4597&s=f5e82bfa901352bc4e26869347bf8a4d7b6466e7
Patch1:             palo-5.1.4-systemd-unit.patch
URL:                http://www.jedox.com/community/palo-forum/
BuildRequires:      subversion
BuildRequires:      cmake
BuildRequires:      zlib-devel
BuildRequires:      openssl-devel
BuildRequires:      boost-devel
BuildRequires:      icu
BuildRequires:      libicu-devel
BuildRequires:      gperftools-devel
BuildRequires:      gettext
BuildRequires:      systemd

%description
Palo is a cell-oriented, multiple dimension in-memory OLAP server typically used
for analysis and data consolidation. Multiple dimension data can be queried 
interactively and written back for further consolidation. The server stores and
manipulates data in memory. Bespoke Java, PHP, C/C++, and .NET clients can 
access the palo database via an API or plug-in modules are available for 
spreadsheet applications.

%prep
%setup -q
#Patch the CMakeLists.txt to ensure its fedora compatible
%patch0 -p1
#Patch the source to include the systemd unit
%patch1 -p1

%build
#Create a build directory for cmake
mkdir --parents %{_builddir}/build
cd %{_builddir}/build
#As this is a server enable position-independent code (PIC)
%global _hardened_build 1
#Use cmake to build
%cmake ../%{name}-%{version}/
make %{?_smp_mflags}

%install
#Create the folder structure
mkdir --parents %{buildroot}%{_bindir}
mkdir --parents %{buildroot}%{_libdir}
mkdir --parents %{buildroot}%{_sysconfdir}
mkdir --parents %{buildroot}%{_sharedstatedir}/%{name}/Data
mkdir --parents %{buildroot}%{_unitdir}
install --mode=0755 %{_builddir}/build%{_bindir}/%{name} %{buildroot}%{_bindir}
install --mode=0755 %{_builddir}/build%{_libdir}/libhttps.%{name}.* %{buildroot}%{_libdir}
#Copy accross the runtime configuration file
cp %{_builddir}/%{name}-%{version}/%{name}.ini.sample %{buildroot}%{_sysconfdir}/%{name}.ini
#The systemd unit file is provided by the package maintainer as Patch1
install --mode=0644 %{_builddir}/%{name}-%{version}/%{name}.service %{buildroot}%{_unitdir}

#Ensure the ldconfig is called on install and uninstall so the .so's work as expected
%post -p /sbin/ldconfig
%postun -p /sbin/ldconfig

%files
#Documentation and license files as provided by upstream
%license LICENSE
%doc README CHANGELOG
#Files owned by the package
%{_bindir}/%{name}
%{_libdir}/libhttps.%{name}.*
#Directories owned by the package
%{_sharedstatedir}/%{name}
#Tag the config files so they don't get overridden
%config(noreplace) %{_sysconfdir}/%{name}.ini
%verify() %{_unitdir}/%{name}.service

%changelog
* Tue Oct 6 2015 Michael Arnold <myk321@gmail.com> - 5.1-4
- Made corrections to the palo.spec file based on the output of fedora-review -b 1209166
* Thu Apr 9 2015 Michael Arnold <myk321@gmail.com> - 5.1-4
- Updated BuildRequires to fix Koji builds
- Further modifications to patch0, to remove hard-coded paths to ensure that cmake finds dependencies reliably
* Sun Mar 29 2015 Michael Arnold <myk321@gmail.com> - 5.1-4
- Created initial palo.spec file based on https://fedoraproject.org/wiki/How_to_create_an_RPM_package

